#pragma once

#include "../Netzwerk/EditorKlient.h"
#include <Punkt.h>
#include <Critical.h>
#include <functional>

namespace Editor
{
    struct SpielerDaten
    {
        int id;
        Punkt pos;
        double rot;
        double beschleunigung;
        int maxStabilitt;
        int maxEnergie;
        double reparatur;
        double akkuLeistung;
        int laserIntensitt;
        int laserEffizienz;
        int laserTempo;
        double wendigkeit;
        double antriebEffizienz;
        int netzwerk;
        int skillPunkte;
        int m2d;
        int bild;
    };

    struct TeamDaten
    {
        int id;
        int maxPunkte;
        double beschleunigung;
        int maxStabilitt;
        int maxEnergie;
        double reparatur;
        double akkuLeistung;
        int laserIntensitt;
        int laserEffizienz;
        int laserTempo;
        double wendigkeit;
        double antriebEffizienz;
        int punkte;
    };

    struct ObjektDaten
    {
        Punkt pos;
        int id;
        int m2d;
        int bild;
        int style;
        int maxStabilitt;
        int maxEnergie;
        int energieRadius;
        double reparatur;
        double akkuLeistung;
        char team;
    };

    class KarteDaten : private Thread
    {
    private:
        EditorKlient * client;
        SpielerTeamStruktur *sts;
        Array< SpielerDaten* > spieler;
        Array< TeamDaten* > teams;
        Array< ObjektDaten* > objekte;
        Text error;
        Array< std::function< void() > > aktionen;
        Critical cs;
        bool exit;
        int ref;

    public:
        KarteDaten( EditorKlient *client );
        ~KarteDaten();
        void addObjekt( ObjektDaten &daten );
        void removeObjekt( int index );
        void getObjekt( int index, std::function< bool( ObjektDaten* ) > callBack );
        void getSpieler( int index, std::function< bool( SpielerDaten* ) > callBack );
        void getTeam( int index, std::function< bool( TeamDaten* ) > callBack );
        void thread() override;
        const ObjektDaten *getObjekt( int index );
        const SpielerDaten *getSpieler( int index );
        const TeamDaten *getTeam( int index );
        int getSpielerIndexById( int id );
        int getSpielerAnzahl() const;
        int getTeamIndexById( int id );
        int getTeamAnzahl() const;
        int getObjektAnzahl() const;
        bool hasError() const;
        char *getError() const;
        bool hasAktions() const;
        KarteDaten *getThis();
        KarteDaten *release();
    };
}