#ifndef SpielObjekt_H
#define SpielObjekt_H

#include <Vec2.h>
#include <Model2D.h>
#include "../Team/Team.h"
#include "../Karte/Strukturen.h"
#include <TextFeld.h>

using namespace Framework;

class SpielObjekt
{
private:
	Vec2< double > pos;
	int id;
	Model2D *mdl;
	int style;
	double stabilitt;
	double energie;
	int maxStabilitt;
	int maxEnergie;
	int energieRadius;
	double reparatur;
	double akkuLeistung;
	double repAbk;
	double akkuAbk;
	Team *team;
	TextFeld *nText;
	int ref;

public:
	// Konstruktor
	SpielObjekt( ObjektStr *zStr, Schrift *zSchrift );
	// Destruktor
	~SpielObjekt();
	// nicht constant
	void setModelData( Model2DData *data );
	void setTextur( Bild *textur );
	void setTeam( Team *team );
	void tick();
	void render( Bild &zRObj );
	void renderLeben( Bild &zRObj );
	// constant
	Team *zTeam() const;
	// Reference Counting
	SpielObjekt *getThis();
	SpielObjekt *release();
};

#endif