#ifndef Laser_H
#define Laser_H

#include <Vec2.h>
#include <Bild.h>

using namespace Framework;

class Karte;

class Laser
{
private:
	int ref;
	int id;
	Vec2< double > pos;
	Vec2< double > speed;
	double intensitt;
	double startIntensitt;
	int tf;
	int sNum;
	// privat
	char getOutCode( Punkt& p, Bild &zrObj ) const;

public:
	// Konstruktor
	Laser( int id, Vec2< double > pos, Vec2< double > speed, int sNum, double intensitt, int tf );
	// nicht constant
	void tick( int tick, Karte *zMap );
	void render( Bild &zRObj );
	void renderMinimap( Bild &zRObj, Karte *zMap );
	// constant
	int getId() const;
	int getSpieler() const;
	double getIntensitt( Vec2< double > targetSpeed ) const;
    Vec2< double > getPos() const;
    Vec2< double > getSpeed() const;
	// Reference Counting
	Laser *getThis();
	Laser *release();
};

#endif